![Oracle Logo](https://raw.githubusercontent.com/oracle/dotnet-db-samples/master/images/oracle-nuget.png) 
# Oracle.ManagedDataAccess.Core 23.3.2-dev
Release Notes for Oracle Data Provider for .NET Core NuGet Package

March 2024

Oracle Data Provider for .NET (ODP.NET) Core features optimized ADO.NET data access to the Oracle database for .NET (Core) runtime. ODP.NET allows developers to take advantage of advanced Oracle database functionality, including Real Application Clusters, self-tuning statement cache, Application Continuity, JSON Relational Duality, and Fast Connection Failover. 

This document provides information that supplements the [Oracle Data Provider for .NET (ODP.NET) documentation](https://docs.oracle.com/en/database/oracle/oracle-database/23/odpnt/index.html).

## Oracle .NET Links
* [Oracle .NET Home Page](https://www.oracle.com/database/technologies/appdev/dotnet.html)
* [GitHub - Sample Code](https://github.com/oracle/dotnet-db-samples)
* [ODP.NET Discussion Forum](https://forums.oracle.com/ords/apexds/domain/dev-community/category/odp-dot-net)
* [YouTube](https://www.youtube.com/user/OracleDOTNETTeam)
* [X (Twitter)](https://twitter.com/oracledotnet)
* [Email Newsletter Sign Up](https://go.oracle.com/LP=28277?elqCampaignId=124071&nsl=onetdev)

## New Features
* .NET Metrics
     .NET Metrics are application numerical measurements collected at regular time intervals for the purposes of monitoring and alerting about application health. In an ODP.NET setting, metrics can monitor connection statistics, such as number of ODP.NET hard connections to the database, number of active connections, or number of free connections. Starting with version 23.3.2, ODP.NET Core supports .NET Metrics.
     Note: The ODP.NET metrics source name is "Oracle.ManagedDataAccess.Core" for ODP.NET Core.
* OpenTelemetry – Automatic Instrumentation and Dynamic Enablement
     ODP.NET adds new OpenTelemetry automatic instrumentation support that delivers traces to observability backends without requiring source code changes. ODP.NET OpenTelemetry is now enabled automatically. It no longer requires adding Oracle.ManagedDataAccess.OpenTelemetry NuGet package nor calling AddOracleDataProviderInstrumentation() extension method to enable OpenTelemetry.
     ODP.NET OpenTelemetry is now enabled by default. It can be turned off or on by setting OracleConfiguration.OpenTelemetryTracing to false or true, respectively. It can also be set in the OpenTelemetryTracing .NET configuration file setting for .NET Framework.
     Note: The ODP.NET activity source name is "Oracle.ManagedDataAccess.Core" for ODP.NET Core.
     Note: Applications will still need to add Oracle.ManagedDataAccess.OpenTelemetry NuGet package to the application and call the AddOracleDataProviderInstrumentation() extension method by passing in an OracleDataProviderInstrumentationOptions object to set non-default option settings.

## Bug Fixes since Oracle.ManagedDataAccess.Core 23.3.1-dev
* Bug 35711274 ORA-00904: SHARDED INVALID IDENTIFIER WHEN ADDING EVENT HANDLER TO ORACLEAQQUEUE.MESSAGEAVAILABLE
* Bug 35666844 ORA-50000: CONNECTION REQUEST TIMED OUT WHEN USING ASYNC AND CONNECTION POOLING
* Bug 35698455 ORA-50028: INVALID PARAMETER BINDING WHEN USING ARRAY BINDING WITH ASYNC APIS
* Bug 35711258 AQ ORACLEAQAGENT CONSTRUCTOR WITH NULL NAME PARAMETER CAUSES ARGUMENTNULLEXCEPTION
* Bug 35778668 PIPELINING OPERATION BLOCKS THE APPLICATION THREAD
* Bug 35901069 ORA-50028: INVALID PARAMETER BINDING (PARAMETER '1') WHEN USING BIND BY NAME WITH UDTS


 Copyright (c) 2024, Oracle and/or its affiliates. 
